--- old/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
+++ new/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
@@ -4754,17 +4496,17 @@
 	if (policy.zrp_request & ZPOOL_DO_REWIND)
 		state = SPA_LOAD_RECOVER;
 
-	spa->spa_config_source = SPA_CONFIG_SRC_TRYIMPORT;
-
-	if (state != SPA_LOAD_RECOVER) {
+	/*
+	 * Pass off the heavy lifting to spa_load().  Pass TRUE for mosconfig
+	 * because the user-supplied config is actually the one to trust when
+	 * doing an import.
+	 */
+	if (state != SPA_LOAD_RECOVER)
 		spa->spa_last_ubsync_txg = spa->spa_load_txg = 0;
-		zfs_dbgmsg("spa_import: importing %s", pool);
-	} else {
-		zfs_dbgmsg("spa_import: importing %s, max_txg=%lld "
-		    "(RECOVERY MODE)", pool, (longlong_t)policy.zrp_txg);
-	}
-	error = spa_load_best(spa, state, policy.zrp_txg, policy.zrp_request);
 
+	error = spa_load_best(spa, state, B_TRUE, policy.zrp_txg,
+	    policy.zrp_request);
+
 	/*
 	 * Propagate anything learned while loading the pool and pass it
 	 * back to caller (i.e. rewind info, missing devices, etc).
@@ -4810,8 +4552,6 @@
 		return (error);
 	}
 
-	spa_async_resume(spa);
-
 	/*
 	 * Override any spares and level 2 cache devices as specified by
 	 * the user, as these may have correct device names/devids, etc.
@@ -4847,6 +4587,9 @@
 		spa->spa_l2cache.sav_sync = B_TRUE;
 	}
 
+	/* At this point, we can load spare props */
+	(void) spa_load_vdev_props(spa);
+
 	/*
 	 * Check for any removed devices.
 	 */
@@ -4863,11 +4606,22 @@
 	}
 
 	/*
+	 * Start async resume as late as possible to reduce I/O activity when
+	 * importing a pool. This will let any pending txgs (e.g. from scrub
+	 * or resilver) to complete quickly thereby reducing import times in
+	 * such cases.
+	 */
+	spa_async_resume(spa);
+
+	/*
 	 * It's possible that the pool was expanded while it was exported.
 	 * We kick off an async task to handle this for us.
 	 */
 	spa_async_request(spa, SPA_ASYNC_AUTOEXPAND);
 
+	/* Set/activate meta feature as needed */
+	if (!spa_writeable(spa))
+		spa_check_special_feature(spa);
 	spa_history_log_version(spa, "import");
 
 	spa_event_notify(spa, NULL, NULL, ESC_ZFS_POOL_IMPORT);
@@ -4874,7 +4628,13 @@
 
 	mutex_exit(&spa_namespace_lock);
 
-	return (0);
+	if (!spa_writeable(spa))
+		return (0);
+
+	wbc_activate(spa, B_FALSE);
+
+	return (dsl_sync_task(spa->spa_name, NULL, spa_special_feature_activate,
+	    spa, 3, ZFS_SPACE_CHECK_RESERVED));
 }
 
 nvlist_t *
@@ -4881,11 +4641,10 @@
 spa_tryimport(nvlist_t *tryconfig)
 {
 	nvlist_t *config = NULL;
-	char *poolname, *cachefile;
+	char *poolname;
 	spa_t *spa;
 	uint64_t state;
 	int error;
-	zpool_rewind_policy_t policy;
 
 	if (nvlist_lookup_string(tryconfig, ZPOOL_CONFIG_POOL_NAME, &poolname))
 		return (NULL);
@@ -4901,30 +4660,12 @@
 	spa_activate(spa, FREAD);
 
 	/*
-	 * Rewind pool if a max txg was provided. Note that even though we
-	 * retrieve the complete rewind policy, only the rewind txg is relevant
-	 * for tryimport.
+	 * Pass off the heavy lifting to spa_load().
+	 * Pass TRUE for mosconfig because the user-supplied config
+	 * is actually the one to trust when doing an import.
 	 */
-	zpool_get_rewind_policy(spa->spa_config, &policy);
-	if (policy.zrp_txg != UINT64_MAX) {
-		spa->spa_load_max_txg = policy.zrp_txg;
-		spa->spa_extreme_rewind = B_TRUE;
-		zfs_dbgmsg("spa_tryimport: importing %s, max_txg=%lld",
-		    poolname, (longlong_t)policy.zrp_txg);
-	} else {
-		zfs_dbgmsg("spa_tryimport: importing %s", poolname);
-	}
+	error = spa_load(spa, SPA_LOAD_TRYIMPORT, SPA_IMPORT_EXISTING, B_TRUE);
 
-	if (nvlist_lookup_string(tryconfig, ZPOOL_CONFIG_CACHEFILE, &cachefile)
-	    == 0) {
-		zfs_dbgmsg("spa_tryimport: using cachefile '%s'", cachefile);
-		spa->spa_config_source = SPA_CONFIG_SRC_CACHEFILE;
-	} else {
-		spa->spa_config_source = SPA_CONFIG_SRC_SCAN;
-	}
-
-	error = spa_load(spa, SPA_LOAD_TRYIMPORT, SPA_IMPORT_EXISTING);
-
 	/*
 	 * If 'tryconfig' was at least parsable, return the current config.
 	 */
@@ -4999,9 +4740,11 @@
  */
 static int
 spa_export_common(char *pool, int new_state, nvlist_t **oldconfig,
-    boolean_t force, boolean_t hardforce)
+    boolean_t force, boolean_t hardforce, boolean_t saveconfig)
 {
 	spa_t *spa;
+	zfs_autosnap_t *autosnap;
+	boolean_t wbcthr_stopped = B_FALSE;
 
 	if (oldconfig)
 		*oldconfig = NULL;
@@ -5016,11 +4759,27 @@
 	}
 
 	/*
-	 * Put a hold on the pool, drop the namespace lock, stop async tasks,
-	 * reacquire the namespace lock, and see if we can export.
+	 * Put a hold on the pool, drop the namespace lock, stop async tasks
+	 * and write cache thread, reacquire the namespace lock, and see
+	 * if we can export.
 	 */
 	spa_open_ref(spa, FTAG);
 	mutex_exit(&spa_namespace_lock);
+
+	autosnap = spa_get_autosnap(spa);
+	mutex_enter(&autosnap->autosnap_lock);
+
+	if (autosnap_has_children_zone(autosnap,
+	    spa_name(spa), B_TRUE)) {
+		mutex_exit(&autosnap->autosnap_lock);
+		spa_close(spa, FTAG);
+		return (EBUSY);
+	}
+
+	mutex_exit(&autosnap->autosnap_lock);
+
+	wbcthr_stopped = wbc_stop_thread(spa); /* stop write cache thread */
+	autosnap_destroyer_thread_stop(spa);
 	spa_async_suspend(spa);
 	mutex_enter(&spa_namespace_lock);
 	spa_close(spa, FTAG);
@@ -5047,6 +4806,9 @@
 		    new_state != POOL_STATE_UNINITIALIZED)) {
 			spa_async_resume(spa);
 			mutex_exit(&spa_namespace_lock);
+			if (wbcthr_stopped)
+				(void) wbc_start_thread(spa);
+			autosnap_destroyer_thread_start(spa);
 			return (SET_ERROR(EBUSY));
 		}
 
@@ -5060,6 +4822,9 @@
 		    spa_has_active_shared_spare(spa)) {
 			spa_async_resume(spa);
 			mutex_exit(&spa_namespace_lock);
+			if (wbcthr_stopped)
+				(void) wbc_start_thread(spa);
+			autosnap_destroyer_thread_start(spa);
 			return (SET_ERROR(EXDEV));
 		}
 
@@ -5081,6 +4846,8 @@
 	spa_event_notify(spa, NULL, NULL, ESC_ZFS_POOL_DESTROY);
 
 	if (spa->spa_state != POOL_STATE_UNINITIALIZED) {
+		wbc_deactivate(spa);
+
 		spa_unload(spa);
 		spa_deactivate(spa);
 	}
@@ -5090,7 +4857,8 @@
 
 	if (new_state != POOL_STATE_UNINITIALIZED) {
 		if (!hardforce)
-			spa_write_cachefile(spa, B_TRUE, B_TRUE);
+			spa_config_sync(spa, !saveconfig, B_TRUE);
+
 		spa_remove(spa);
 	}
 	mutex_exit(&spa_namespace_lock);
@@ -5105,7 +4873,7 @@
 spa_destroy(char *pool)
 {
 	return (spa_export_common(pool, POOL_STATE_DESTROYED, NULL,
-	    B_FALSE, B_FALSE));
+	    B_FALSE, B_FALSE, B_FALSE));
 }
 
 /*
@@ -5113,10 +4881,10 @@
  */
 int
 spa_export(char *pool, nvlist_t **oldconfig, boolean_t force,
-    boolean_t hardforce)
+    boolean_t hardforce, boolean_t saveconfig)
 {
 	return (spa_export_common(pool, POOL_STATE_EXPORTED, oldconfig,
-	    force, hardforce));
+	    force, hardforce, saveconfig));
 }
 
 /*
@@ -5127,7 +4895,7 @@
 spa_reset(char *pool)
 {
 	return (spa_export_common(pool, POOL_STATE_UNINITIALIZED, NULL,
-	    B_FALSE, B_FALSE));
+	    B_FALSE, B_FALSE, B_FALSE));
 }
 
 /*
@@ -5148,6 +4916,7 @@
 	vdev_t *vd, *tvd;
 	nvlist_t **spares, **l2cache;
 	uint_t nspares, nl2cache;
+	dmu_tx_t *tx = NULL;
 
 	ASSERT(spa_writeable(spa));
 
@@ -5182,41 +4951,8 @@
 		return (spa_vdev_exit(spa, vd, txg, error));
 
 	/*
-	 * If we are in the middle of a device removal, we can only add
-	 * devices which match the existing devices in the pool.
-	 * If we are in the middle of a removal, or have some indirect
-	 * vdevs, we can not add raidz toplevels.
+	 * Transfer each new top-level vdev from vd to rvd.
 	 */
-	if (spa->spa_vdev_removal != NULL ||
-	    spa->spa_removing_phys.sr_prev_indirect_vdev != -1) {
-		for (int c = 0; c < vd->vdev_children; c++) {
-			tvd = vd->vdev_child[c];
-			if (spa->spa_vdev_removal != NULL &&
-			    tvd->vdev_ashift !=
-			    spa->spa_vdev_removal->svr_vdev->vdev_ashift) {
-				return (spa_vdev_exit(spa, vd, txg, EINVAL));
-			}
-			/* Fail if top level vdev is raidz */
-			if (tvd->vdev_ops == &vdev_raidz_ops) {
-				return (spa_vdev_exit(spa, vd, txg, EINVAL));
-			}
-			/*
-			 * Need the top level mirror to be
-			 * a mirror of leaf vdevs only
-			 */
-			if (tvd->vdev_ops == &vdev_mirror_ops) {
-				for (uint64_t cid = 0;
-				    cid < tvd->vdev_children; cid++) {
-					vdev_t *cvd = tvd->vdev_child[cid];
-					if (!cvd->vdev_ops->vdev_op_leaf) {
-						return (spa_vdev_exit(spa, vd,
-						    txg, EINVAL));
-					}
-				}
-			}
-		}
-	}
-
 	for (int c = 0; c < vd->vdev_children; c++) {
 
 		/*
@@ -5269,6 +5005,19 @@
 	spa_event_notify(spa, NULL, NULL, ESC_ZFS_VDEV_ADD);
 	mutex_exit(&spa_namespace_lock);
 
+	/*
+	 * "spa_last_synced_txg(spa) + 1" is used because:
+	 *   - spa_vdev_exit() calls txg_wait_synced() for "txg"
+	 *   - spa_config_update() calls txg_wait_synced() for
+	 *     "spa_last_synced_txg(spa) + 1"
+	 */
+	tx = dmu_tx_create_assigned(spa_get_dsl(spa),
+	    spa_last_synced_txg(spa) + 1);
+	spa_special_feature_activate(spa, tx);
+	dmu_tx_commit(tx);
+
+	wbc_activate(spa, B_FALSE);
+
 	return (0);
 }
 
@@ -5302,11 +5051,6 @@
 
 	oldvd = spa_lookup_by_guid(spa, guid, B_FALSE);
 
-	if (spa->spa_vdev_removal != NULL ||
-	    spa->spa_removing_phys.sr_prev_indirect_vdev != -1) {
-		return (spa_vdev_exit(spa, NULL, txg, EBUSY));
-	}
-
 	if (oldvd == NULL)
 		return (spa_vdev_exit(spa, NULL, txg, ENODEV));
 
@@ -5472,6 +5216,14 @@
 	spa_event_notify(spa, newvd, NULL, ESC_ZFS_VDEV_ATTACH);
 
 	/*
+	 * Check CoS property of the old vdev, add reference by new vdev
+	 */
+	if (oldvd->vdev_queue.vq_cos) {
+		cos_hold(oldvd->vdev_queue.vq_cos);
+		newvd->vdev_queue.vq_cos = oldvd->vdev_queue.vq_cos;
+	}
+
+	/*
 	 * Commit the config
 	 */
 	(void) spa_vdev_exit(spa, newrootvd, dtl_max_txg, 0);
@@ -5685,6 +5437,14 @@
 
 	spa_event_notify(spa, vd, NULL, ESC_ZFS_VDEV_REMOVE);
 
+	/*
+	 * Release the references to CoS descriptors if any
+	 */
+	if (vd->vdev_queue.vq_cos) {
+		cos_rele(vd->vdev_queue.vq_cos);
+		vd->vdev_queue.vq_cos = NULL;
+	}
+
 	/* hang on to the spa before we release the lock */
 	spa_open_ref(spa, FTAG);
 
@@ -5747,12 +5507,19 @@
 
 	ASSERT(spa_writeable(spa));
 
+	/*
+	 * split for pools with activated WBC
+	 * will be implemented in the next release
+	 */
+	if (spa_feature_is_active(spa, SPA_FEATURE_WBC))
+		return (SET_ERROR(ENOTSUP));
+
 	txg = spa_vdev_enter(spa);
 
 	/* clear the log and flush everything up to now */
 	activate_slog = spa_passivate_log(spa);
 	(void) spa_vdev_config_exit(spa, NULL, txg, 0, FTAG);
-	error = spa_reset_logs(spa);
+	error = spa_offline_log(spa);
 	txg = spa_vdev_config_enter(spa);
 
 	if (activate_slog)
@@ -5780,7 +5547,7 @@
 		vdev_t *vd = rvd->vdev_child[c];
 
 		/* don't count the holes & logs as children */
-		if (vd->vdev_islog || !vdev_is_concrete(vd)) {
+		if (vd->vdev_islog || vd->vdev_ishole) {
 			if (lastlog == 0)
 				lastlog = c;
 			continue;
@@ -5833,7 +5600,7 @@
 		/* make sure there's nothing stopping the split */
 		if (vml[c]->vdev_parent->vdev_ops != &vdev_mirror_ops ||
 		    vml[c]->vdev_islog ||
-		    !vdev_is_concrete(vml[c]) ||
+		    vml[c]->vdev_ishole ||
 		    vml[c]->vdev_isspare ||
 		    vml[c]->vdev_isl2cache ||
 		    !vdev_writeable(vml[c]) ||
@@ -5928,10 +5695,8 @@
 	spa_activate(newspa, spa_mode_global);
 	spa_async_suspend(newspa);
 
-	newspa->spa_config_source = SPA_CONFIG_SRC_SPLIT;
-
 	/* create the new pool from the disks of the original pool */
-	error = spa_load(newspa, SPA_LOAD_IMPORT, SPA_IMPORT_ASSEMBLE);
+	error = spa_load(newspa, SPA_LOAD_IMPORT, SPA_IMPORT_ASSEMBLE, B_TRUE);
 	if (error)
 		goto out;
 
@@ -5971,6 +5736,18 @@
 		dmu_tx_abort(tx);
 	for (c = 0; c < children; c++) {
 		if (vml[c] != NULL) {
+			vdev_t *tvd = vml[c]->vdev_top;
+
+			/*
+			 * Need to be sure the detachable VDEV is not
+			 * on any *other* txg's DTL list to prevent it
+			 * from being accessed after it's freed.
+			 */
+			for (int t = 0; t < TXG_SIZE; t++) {
+				(void) txg_list_remove_this(
+				    &tvd->vdev_dtl_list, vml[c], t);
+			}
+
 			vdev_split(vml[c]);
 			if (error == 0)
 				spa_history_log_internal(spa, "detach", tx,
@@ -5999,7 +5776,7 @@
 	/* if we're not going to mount the filesystems in userland, export */
 	if (exp)
 		error = spa_export_common(newname, POOL_STATE_EXPORTED, NULL,
-		    B_FALSE, B_FALSE);
+		    B_FALSE, B_FALSE, B_FALSE);
 
 	return (error);
 
@@ -6025,7 +5802,304 @@
 	return (error);
 }
 
+static nvlist_t *
+spa_nvlist_lookup_by_guid(nvlist_t **nvpp, int count, uint64_t target_guid)
+{
+	for (int i = 0; i < count; i++) {
+		uint64_t guid;
+
+		VERIFY(nvlist_lookup_uint64(nvpp[i], ZPOOL_CONFIG_GUID,
+		    &guid) == 0);
+
+		if (guid == target_guid)
+			return (nvpp[i]);
+	}
+
+	return (NULL);
+}
+
+static void
+spa_vdev_remove_aux(nvlist_t *config, char *name, nvlist_t **dev, int count,
+    nvlist_t *dev_to_remove)
+{
+	nvlist_t **newdev = NULL;
+
+	if (count > 1)
+		newdev = kmem_alloc((count - 1) * sizeof (void *), KM_SLEEP);
+
+	for (int i = 0, j = 0; i < count; i++) {
+		if (dev[i] == dev_to_remove)
+			continue;
+		VERIFY(nvlist_dup(dev[i], &newdev[j++], KM_SLEEP) == 0);
+	}
+
+	VERIFY(nvlist_remove(config, name, DATA_TYPE_NVLIST_ARRAY) == 0);
+	VERIFY(nvlist_add_nvlist_array(config, name, newdev, count - 1) == 0);
+
+	for (int i = 0; i < count - 1; i++)
+		nvlist_free(newdev[i]);
+
+	if (count > 1)
+		kmem_free(newdev, (count - 1) * sizeof (void *));
+}
+
 /*
+ * Evacuate the device.
+ */
+static int
+spa_vdev_remove_evacuate(spa_t *spa, vdev_t *vd)
+{
+	uint64_t txg;
+	int error = 0;
+
+	ASSERT(MUTEX_HELD(&spa_namespace_lock));
+	ASSERT(spa_config_held(spa, SCL_ALL, RW_WRITER) == 0);
+	ASSERT(vd == vd->vdev_top);
+
+	/*
+	 * Evacuate the device.  We don't hold the config lock as writer
+	 * since we need to do I/O but we do keep the
+	 * spa_namespace_lock held.  Once this completes the device
+	 * should no longer have any blocks allocated on it.
+	 */
+	if (vd->vdev_islog) {
+		if (vd->vdev_stat.vs_alloc != 0)
+			error = spa_offline_log(spa);
+	} else {
+		error = SET_ERROR(ENOTSUP);
+	}
+
+	if (error)
+		return (error);
+
+	/*
+	 * The evacuation succeeded.  Remove any remaining MOS metadata
+	 * associated with this vdev, and wait for these changes to sync.
+	 */
+	ASSERT0(vd->vdev_stat.vs_alloc);
+	txg = spa_vdev_config_enter(spa);
+	vd->vdev_removing = B_TRUE;
+	vdev_dirty_leaves(vd, VDD_DTL, txg);
+	vdev_config_dirty(vd);
+	spa_vdev_config_exit(spa, NULL, txg, 0, FTAG);
+
+	return (0);
+}
+
+/*
+ * Complete the removal by cleaning up the namespace.
+ */
+static void
+spa_vdev_remove_from_namespace(spa_t *spa, vdev_t *vd)
+{
+	vdev_t *rvd = spa->spa_root_vdev;
+	uint64_t id = vd->vdev_id;
+	boolean_t last_vdev = (id == (rvd->vdev_children - 1));
+
+	ASSERT(MUTEX_HELD(&spa_namespace_lock));
+	ASSERT(spa_config_held(spa, SCL_ALL, RW_WRITER) == SCL_ALL);
+	ASSERT(vd == vd->vdev_top);
+
+	/*
+	 * Only remove any devices which are empty.
+	 */
+	if (vd->vdev_stat.vs_alloc != 0)
+		return;
+
+	(void) vdev_label_init(vd, 0, VDEV_LABEL_REMOVE);
+
+	if (list_link_active(&vd->vdev_state_dirty_node))
+		vdev_state_clean(vd);
+	if (list_link_active(&vd->vdev_config_dirty_node))
+		vdev_config_clean(vd);
+
+	vdev_free(vd);
+
+	if (last_vdev) {
+		vdev_compact_children(rvd);
+	} else {
+		vd = vdev_alloc_common(spa, id, 0, &vdev_hole_ops);
+		vdev_add_child(rvd, vd);
+	}
+	vdev_config_dirty(rvd);
+
+	/*
+	 * Reassess the health of our root vdev.
+	 */
+	vdev_reopen(rvd);
+}
+
+/*
+ * Remove a device from the pool -
+ *
+ * Removing a device from the vdev namespace requires several steps
+ * and can take a significant amount of time.  As a result we use
+ * the spa_vdev_config_[enter/exit] functions which allow us to
+ * grab and release the spa_config_lock while still holding the namespace
+ * lock.  During each step the configuration is synced out.
+ *
+ * Currently, this supports removing only hot spares, slogs, level 2 ARC
+ * and special devices.
+ */
+int
+spa_vdev_remove(spa_t *spa, uint64_t guid, boolean_t unspare)
+{
+	vdev_t *vd;
+	sysevent_t *ev = NULL;
+	metaslab_group_t *mg;
+	nvlist_t **spares, **l2cache, *nv;
+	uint64_t txg = 0;
+	uint_t nspares, nl2cache;
+	int error = 0;
+	boolean_t locked = MUTEX_HELD(&spa_namespace_lock);
+
+	ASSERT(spa_writeable(spa));
+
+	if (!locked)
+		txg = spa_vdev_enter(spa);
+
+	vd = spa_lookup_by_guid(spa, guid, B_FALSE);
+
+	if (spa->spa_spares.sav_vdevs != NULL &&
+	    nvlist_lookup_nvlist_array(spa->spa_spares.sav_config,
+	    ZPOOL_CONFIG_SPARES, &spares, &nspares) == 0 &&
+	    (nv = spa_nvlist_lookup_by_guid(spares, nspares, guid)) != NULL) {
+		/*
+		 * Only remove the hot spare if it's not currently in use
+		 * in this pool.
+		 */
+		if (vd == NULL || unspare) {
+			if (vd == NULL)
+				vd = spa_lookup_by_guid(spa, guid, B_TRUE);
+
+			/*
+			 * Release the references to CoS descriptors if any
+			 */
+			if (vd != NULL && vd->vdev_queue.vq_cos) {
+				cos_rele(vd->vdev_queue.vq_cos);
+				vd->vdev_queue.vq_cos = NULL;
+			}
+
+			ev = spa_event_create(spa, vd, NULL, ESC_ZFS_VDEV_REMOVE_AUX);
+			spa_vdev_remove_aux(spa->spa_spares.sav_config,
+			    ZPOOL_CONFIG_SPARES, spares, nspares, nv);
+			spa_load_spares(spa);
+			spa->spa_spares.sav_sync = B_TRUE;
+		} else {
+			error = SET_ERROR(EBUSY);
+		}
+	} else if (spa->spa_l2cache.sav_vdevs != NULL &&
+	    nvlist_lookup_nvlist_array(spa->spa_l2cache.sav_config,
+	    ZPOOL_CONFIG_L2CACHE, &l2cache, &nl2cache) == 0 &&
+	    (nv = spa_nvlist_lookup_by_guid(l2cache, nl2cache, guid)) != NULL) {
+		/*
+		 * Cache devices can always be removed.
+		 */
+		if (vd == NULL)
+			vd = spa_lookup_by_guid(spa, guid, B_TRUE);
+		/*
+		 * Release the references to CoS descriptors if any
+		 */
+		if (vd != NULL && vd->vdev_queue.vq_cos) {
+			cos_rele(vd->vdev_queue.vq_cos);
+			vd->vdev_queue.vq_cos = NULL;
+		}
+
+		ev = spa_event_create(spa, vd, NULL, ESC_ZFS_VDEV_REMOVE_AUX);
+		spa_vdev_remove_aux(spa->spa_l2cache.sav_config,
+		    ZPOOL_CONFIG_L2CACHE, l2cache, nl2cache, nv);
+		spa_load_l2cache(spa);
+		spa->spa_l2cache.sav_sync = B_TRUE;
+	} else if (vd != NULL && vd->vdev_islog) {
+		ASSERT(!locked);
+
+		if (vd != vd->vdev_top)
+			return (spa_vdev_exit(spa, NULL, txg, SET_ERROR(ENOTSUP)));
+
+		mg = vd->vdev_mg;
+
+		/*
+		 * Stop allocating from this vdev.
+		 */
+		metaslab_group_passivate(mg);
+
+		/*
+		 * Wait for the youngest allocations and frees to sync,
+		 * and then wait for the deferral of those frees to finish.
+		 */
+		spa_vdev_config_exit(spa, NULL,
+		    txg + TXG_CONCURRENT_STATES + TXG_DEFER_SIZE, 0, FTAG);
+
+		/*
+		 * Attempt to evacuate the vdev.
+		 */
+		error = spa_vdev_remove_evacuate(spa, vd);
+
+		txg = spa_vdev_config_enter(spa);
+
+		/*
+		 * If we couldn't evacuate the vdev, unwind.
+		 */
+		if (error) {
+			metaslab_group_activate(mg);
+			return (spa_vdev_exit(spa, NULL, txg, error));
+		}
+
+		/*
+		 * Release the references to CoS descriptors if any
+		 */
+		if (vd->vdev_queue.vq_cos) {
+			cos_rele(vd->vdev_queue.vq_cos);
+			vd->vdev_queue.vq_cos = NULL;
+		}
+
+		ev = spa_event_create(spa, vd, NULL, ESC_ZFS_VDEV_REMOVE_DEV);
+
+		/*
+		 * Clean up the vdev namespace.
+		 */
+		ev = spa_event_create(spa, vd, NULL, ESC_ZFS_VDEV_REMOVE_DEV);
+		spa_vdev_remove_from_namespace(spa, vd);
+
+	} else if (vd != NULL && vdev_is_special(vd)) {
+		ASSERT(!locked);
+
+		if (vd != vd->vdev_top)
+			return (spa_vdev_exit(spa, NULL, txg, SET_ERROR(ENOTSUP)));
+
+		error = spa_special_vdev_remove(spa, vd, &txg);
+		if (error == 0) {
+			ev = spa_event_create(spa, vd, NULL, ESC_ZFS_VDEV_REMOVE_DEV);
+			spa_vdev_remove_from_namespace(spa, vd);
+
+			/*
+			 * User sees this field as 'enablespecial'
+			 * pool-level property
+			 */
+			spa->spa_usesc = B_FALSE;
+		}
+	} else if (vd != NULL) {
+		/*
+		 * Normal vdevs cannot be removed (yet).
+		 */
+		error = SET_ERROR(ENOTSUP);
+	} else {
+		/*
+		 * There is no vdev of any kind with the specified guid.
+		 */
+		error = SET_ERROR(ENOENT);
+	}
+
+	if (!locked)
+		error = spa_vdev_exit(spa, NULL, txg, error);
+
+	if (ev)
+		spa_event_notify_impl(ev);
+
+	return (error);
+}
+
+/*
  * Find any device that's done replacing, or a vdev marked 'unspare' that's
  * currently spared, so we can detach it.
  */
@@ -6062,6 +6136,7 @@
 
 	/*
 	 * Check for a completed resilver with the 'unspare' flag set.
+	 * Also potentially update faulted state.
 	 */
 	if (vd->vdev_ops == &vdev_spare_ops) {
 		vdev_t *first = vd->vdev_child[0];
@@ -6083,6 +6158,8 @@
 		    !vdev_dtl_required(oldvd))
 			return (oldvd);
 
+		vdev_propagate_state(vd);
+
 		/*
 		 * If there are more than two spares attached to a disk,
 		 * and those spares are not required, then we want to
@@ -6143,58 +6220,6 @@
 }
 
 /*
- * Update the stored path or FRU for this vdev.
- */
-int
-spa_vdev_set_common(spa_t *spa, uint64_t guid, const char *value,
-    boolean_t ispath)
-{
-	vdev_t *vd;
-	boolean_t sync = B_FALSE;
-
-	ASSERT(spa_writeable(spa));
-
-	spa_vdev_state_enter(spa, SCL_ALL);
-
-	if ((vd = spa_lookup_by_guid(spa, guid, B_TRUE)) == NULL)
-		return (spa_vdev_state_exit(spa, NULL, ENOENT));
-
-	if (!vd->vdev_ops->vdev_op_leaf)
-		return (spa_vdev_state_exit(spa, NULL, ENOTSUP));
-
-	if (ispath) {
-		if (strcmp(value, vd->vdev_path) != 0) {
-			spa_strfree(vd->vdev_path);
-			vd->vdev_path = spa_strdup(value);
-			sync = B_TRUE;
-		}
-	} else {
-		if (vd->vdev_fru == NULL) {
-			vd->vdev_fru = spa_strdup(value);
-			sync = B_TRUE;
-		} else if (strcmp(value, vd->vdev_fru) != 0) {
-			spa_strfree(vd->vdev_fru);
-			vd->vdev_fru = spa_strdup(value);
-			sync = B_TRUE;
-		}
-	}
-
-	return (spa_vdev_state_exit(spa, sync ? vd : NULL, 0));
-}
-
-int
-spa_vdev_setpath(spa_t *spa, uint64_t guid, const char *newpath)
-{
-	return (spa_vdev_set_common(spa, guid, newpath, B_TRUE));
-}
-
-int
-spa_vdev_setfru(spa_t *spa, uint64_t guid, const char *newfru)
-{
-	return (spa_vdev_set_common(spa, guid, newfru, B_FALSE));
-}
-
-/*
  * ==========================================================================
  * SPA Scanning
  * ==========================================================================
@@ -6391,6 +6416,18 @@
 		dsl_resilver_restart(spa->spa_dsl_pool, 0);
 
 	/*
+	 * Kick off L2 cache rebuilding.
+	 */
+	if (tasks & SPA_ASYNC_L2CACHE_REBUILD)
+		l2arc_spa_rebuild_start(spa);
+
+	if (tasks & SPA_ASYNC_MAN_TRIM_TASKQ_DESTROY) {
+		mutex_enter(&spa->spa_man_trim_lock);
+		spa_man_trim_taskq_destroy(spa);
+		mutex_exit(&spa->spa_man_trim_lock);
+	}
+
+	/*
 	 * Let the world know that we're done.
 	 */
 	mutex_enter(&spa->spa_async_lock);
@@ -6408,12 +6445,6 @@
 	while (spa->spa_async_thread != NULL)
 		cv_wait(&spa->spa_async_cv, &spa->spa_async_lock);
 	mutex_exit(&spa->spa_async_lock);
-
-	spa_vdev_remove_suspend(spa);
-
-	zthr_t *condense_thread = spa->spa_condense_zthr;
-	if (condense_thread != NULL && zthr_isrunning(condense_thread))
-		VERIFY0(zthr_cancel(condense_thread));
 }
 
 void
@@ -6423,11 +6454,6 @@
 	ASSERT(spa->spa_async_suspended != 0);
 	spa->spa_async_suspended--;
 	mutex_exit(&spa->spa_async_lock);
-	spa_restart_removal(spa);
-
-	zthr_t *condense_thread = spa->spa_condense_zthr;
-	if (condense_thread != NULL && !zthr_isrunning(condense_thread))
-		zthr_resume(condense_thread);
 }
 
 static boolean_t
@@ -6472,6 +6498,15 @@
 	mutex_exit(&spa->spa_async_lock);
 }
 
+void
+spa_async_unrequest(spa_t *spa, int task)
+{
+	zfs_dbgmsg("spa=%s async unrequest task=%u", spa->spa_name, task);
+	mutex_enter(&spa->spa_async_lock);
+	spa->spa_async_tasks &= ~task;
+	mutex_exit(&spa->spa_async_lock);
+}
+
 /*
  * ==========================================================================
  * SPA syncing routines
@@ -6760,6 +6795,7 @@
 {
 	nvlist_t *nvp = arg;
 	spa_t *spa = dmu_tx_pool(tx)->dp_spa;
+	spa_meta_placement_t *mp = &spa->spa_meta_policy;
 	objset_t *mos = spa->spa_meta_objset;
 	nvpair_t *elem = NULL;
 
@@ -6774,7 +6810,7 @@
 		spa_feature_t fid;
 
 		switch (prop = zpool_name_to_prop(nvpair_name(elem))) {
-		case ZPOOL_PROP_INVAL:
+		case ZPROP_INVAL:
 			/*
 			 * We checked this earlier in spa_prop_validate().
 			 */
@@ -6872,6 +6908,18 @@
 			case ZPOOL_PROP_DELEGATION:
 				spa->spa_delegation = intval;
 				break;
+			case ZPOOL_PROP_DDT_DESEGREGATION:
+				spa_set_ddt_classes(spa, intval);
+				break;
+			case ZPOOL_PROP_DEDUP_BEST_EFFORT:
+				spa->spa_dedup_best_effort = intval;
+				break;
+			case ZPOOL_PROP_DEDUP_LO_BEST_EFFORT:
+				spa->spa_dedup_lo_best_effort = intval;
+				break;
+			case ZPOOL_PROP_DEDUP_HI_BEST_EFFORT:
+				spa->spa_dedup_hi_best_effort = intval;
+				break;
 			case ZPOOL_PROP_BOOTFS:
 				spa->spa_bootfs = intval;
 				break;
@@ -6878,6 +6926,21 @@
 			case ZPOOL_PROP_FAILUREMODE:
 				spa->spa_failmode = intval;
 				break;
+			case ZPOOL_PROP_FORCETRIM:
+				spa->spa_force_trim = intval;
+				break;
+			case ZPOOL_PROP_AUTOTRIM:
+				mutex_enter(&spa->spa_auto_trim_lock);
+				if (intval != spa->spa_auto_trim) {
+					spa->spa_auto_trim = intval;
+					if (intval != 0)
+						spa_auto_trim_taskq_create(spa);
+					else
+						spa_auto_trim_taskq_destroy(
+						    spa);
+				}
+				mutex_exit(&spa->spa_auto_trim_lock);
+				break;
 			case ZPOOL_PROP_AUTOEXPAND:
 				spa->spa_autoexpand = intval;
 				if (tx->tx_txg != TXG_INITIAL)
@@ -6887,6 +6950,40 @@
 			case ZPOOL_PROP_DEDUPDITTO:
 				spa->spa_dedup_ditto = intval;
 				break;
+			case ZPOOL_PROP_MINWATERMARK:
+				spa->spa_minwat = intval;
+				break;
+			case ZPOOL_PROP_LOWATERMARK:
+				spa->spa_lowat = intval;
+				break;
+			case ZPOOL_PROP_HIWATERMARK:
+				spa->spa_hiwat = intval;
+				break;
+			case ZPOOL_PROP_DEDUPMETA_DITTO:
+				spa->spa_ddt_meta_copies = intval;
+				break;
+			case ZPOOL_PROP_META_PLACEMENT:
+				mp->spa_enable_meta_placement_selection =
+				    intval;
+				break;
+			case ZPOOL_PROP_SYNC_TO_SPECIAL:
+				mp->spa_sync_to_special = intval;
+				break;
+			case ZPOOL_PROP_DDT_META_TO_METADEV:
+				mp->spa_ddt_meta_to_special = intval;
+				break;
+			case ZPOOL_PROP_ZFS_META_TO_METADEV:
+				mp->spa_zfs_meta_to_special = intval;
+				break;
+			case ZPOOL_PROP_SMALL_DATA_TO_METADEV:
+				mp->spa_small_data_to_special = intval;
+				break;
+			case ZPOOL_PROP_RESILVER_PRIO:
+				spa->spa_resilver_prio = intval;
+				break;
+			case ZPOOL_PROP_SCRUB_PRIO:
+				spa->spa_scrub_prio = intval;
+				break;
 			default:
 				break;
 			}
@@ -6972,36 +7069,45 @@
 }
 
 static void
-vdev_indirect_state_sync_verify(vdev_t *vd)
+spa_initialize_alloc_trees(spa_t *spa, uint32_t max_queue_depth,
+    uint64_t queue_depth_total)
 {
-	vdev_indirect_mapping_t *vim = vd->vdev_indirect_mapping;
-	vdev_indirect_births_t *vib = vd->vdev_indirect_births;
+	vdev_t *rvd = spa->spa_root_vdev;
+	boolean_t dva_throttle_enabled = zio_dva_throttle_enabled;
+	metaslab_class_t *mcs[2] = {
+		spa_normal_class(spa),
+		spa_special_class(spa)
+	};
+	size_t mcs_len = sizeof (mcs) / sizeof (metaslab_class_t *);
 
-	if (vd->vdev_ops == &vdev_indirect_ops) {
-		ASSERT(vim != NULL);
-		ASSERT(vib != NULL);
-	}
+	for (size_t i = 0; i < mcs_len; i++) {
+		metaslab_class_t *mc = mcs[i];
 
-	if (vdev_obsolete_sm_object(vd) != 0) {
-		ASSERT(vd->vdev_obsolete_sm != NULL);
-		ASSERT(vd->vdev_removing ||
-		    vd->vdev_ops == &vdev_indirect_ops);
-		ASSERT(vdev_indirect_mapping_num_entries(vim) > 0);
-		ASSERT(vdev_indirect_mapping_bytes_mapped(vim) > 0);
+		ASSERT0(refcount_count(&mc->mc_alloc_slots));
+		mc->mc_alloc_max_slots = queue_depth_total;
+		mc->mc_alloc_throttle_enabled = dva_throttle_enabled;
 
-		ASSERT3U(vdev_obsolete_sm_object(vd), ==,
-		    space_map_object(vd->vdev_obsolete_sm));
-		ASSERT3U(vdev_indirect_mapping_bytes_mapped(vim), >=,
-		    space_map_allocated(vd->vdev_obsolete_sm));
+		ASSERT3U(mc->mc_alloc_max_slots, <=,
+		    max_queue_depth * rvd->vdev_children);
 	}
-	ASSERT(vd->vdev_obsolete_segments != NULL);
+}
 
-	/*
-	 * Since frees / remaps to an indirect vdev can only
-	 * happen in syncing context, the obsolete segments
-	 * tree must be empty when we start syncing.
-	 */
-	ASSERT0(range_tree_space(vd->vdev_obsolete_segments));
+static void
+spa_check_alloc_trees(spa_t *spa)
+{
+	metaslab_class_t *mcs[2] = {
+		spa_normal_class(spa),
+		spa_special_class(spa)
+	};
+	size_t mcs_len = sizeof (mcs) / sizeof (metaslab_class_t *);
+
+	for (size_t i = 0; i < mcs_len; i++) {
+		metaslab_class_t *mc = mcs[i];
+
+		mutex_enter(&mc->mc_alloc_lock);
+		VERIFY0(avl_numnodes(&mc->mc_alloc_tree));
+		mutex_exit(&mc->mc_alloc_lock);
+	}
 }
 
 /*
@@ -7024,13 +7130,6 @@
 	VERIFY(spa_writeable(spa));
 
 	/*
-	 * Wait for i/os issued in open context that need to complete
-	 * before this txg syncs.
-	 */
-	VERIFY0(zio_wait(spa->spa_txg_zio[txg & TXG_MASK]));
-	spa->spa_txg_zio[txg & TXG_MASK] = zio_root(spa, NULL, NULL, 0);
-
-	/*
 	 * Lock out configuration changes.
 	 */
 	spa_config_enter(spa, SCL_CONFIG, FTAG, RW_READER);
@@ -7038,11 +7137,20 @@
 	spa->spa_syncing_txg = txg;
 	spa->spa_sync_pass = 0;
 
-	mutex_enter(&spa->spa_alloc_lock);
-	VERIFY0(avl_numnodes(&spa->spa_alloc_tree));
-	mutex_exit(&spa->spa_alloc_lock);
+	spa_check_alloc_trees(spa);
 
 	/*
+	 * Another pool management task might be currently preventing
+	 * from starting and the current txg sync was invoked on its behalf,
+	 * so be prepared to postpone autotrim processing.
+	 */
+	if (mutex_tryenter(&spa->spa_auto_trim_lock)) {
+		if (spa->spa_auto_trim == SPA_AUTO_TRIM_ON)
+			spa_auto_trim(spa, txg);
+		mutex_exit(&spa->spa_auto_trim_lock);
+	}
+
+	/*
 	 * If there are any pending vdev state changes, convert them
 	 * into config changes that go out with this transaction group.
 	 */
@@ -7117,27 +7225,26 @@
 		mg->mg_max_alloc_queue_depth = max_queue_depth;
 		queue_depth_total += mg->mg_max_alloc_queue_depth;
 	}
-	metaslab_class_t *mc = spa_normal_class(spa);
-	ASSERT0(refcount_count(&mc->mc_alloc_slots));
-	mc->mc_alloc_max_slots = queue_depth_total;
-	mc->mc_alloc_throttle_enabled = zio_dva_throttle_enabled;
 
-	ASSERT3U(mc->mc_alloc_max_slots, <=,
-	    max_queue_depth * rvd->vdev_children);
+	spa_initialize_alloc_trees(spa, max_queue_depth,
+	    queue_depth_total);
 
-	for (int c = 0; c < rvd->vdev_children; c++) {
-		vdev_t *vd = rvd->vdev_child[c];
-		vdev_indirect_state_sync_verify(vd);
-
-		if (vdev_indirect_should_condense(vd)) {
-			spa_condense_indirect_start_sync(vd, tx);
-			break;
-		}
-	}
-
 	/*
 	 * Iterate to convergence.
 	 */
+
+	zfs_autosnap_t *autosnap = spa_get_autosnap(dp->dp_spa);
+	mutex_enter(&autosnap->autosnap_lock);
+
+	autosnap_zone_t *zone = list_head(&autosnap->autosnap_zones);
+	while (zone != NULL) {
+		zone->created = B_FALSE;
+		zone->dirty = B_FALSE;
+		zone = list_next(&autosnap->autosnap_zones, zone);
+	}
+
+	mutex_exit(&autosnap->autosnap_lock);
+
 	do {
 		int pass = ++spa->spa_sync_pass;
 
@@ -7164,11 +7271,7 @@
 		ddt_sync(spa, txg);
 		dsl_scan_sync(dp, tx);
 
-		if (spa->spa_vdev_removal != NULL)
-			svr_sync(spa, tx);
-
-		while ((vd = txg_list_remove(&spa->spa_vdev_txg_list, txg))
-		    != NULL)
+		while (vd = txg_list_remove(&spa->spa_vdev_txg_list, txg))
 			vdev_sync(vd, txg);
 
 		if (pass == 1) {
@@ -7220,10 +7323,6 @@
 		    all_vdev_zap_entry_count);
 	}
 
-	if (spa->spa_vdev_removal != NULL) {
-		ASSERT0(spa->spa_vdev_removal->svr_bytes_done[txg & TXG_MASK]);
-	}
-
 	/*
 	 * Rewrite the vdev configuration (which includes the uberblock)
 	 * to commit the transaction group.
@@ -7241,7 +7340,7 @@
 		spa_config_enter(spa, SCL_STATE, FTAG, RW_READER);
 
 		if (list_is_empty(&spa->spa_config_dirty_list)) {
-			vdev_t *svd[SPA_SYNC_MIN_VDEVS];
+			vdev_t *svd[SPA_DVAS_PER_BP];
 			int svdcount = 0;
 			int children = rvd->vdev_children;
 			int c0 = spa_get_random(children);
